import std.stdio;
import std.c.stdlib;
import std.math;
import std.conv;
import std.file;
import std.json;
import std.algorithm;
import std.string;
import std.array;
import std.datetime;


struct rayzit
{
  string timestamp="0";
  string file_name="";
}


struct tweeter
{
    string month="";
    string date="";
    string hour="";
    string min="";
    string sec="";
    string year="2015";
    string file_name="";
}


//usage message
void usage () {
	writeln("Usage: ./mashup [options]");
  writeln("Please run the script again");
	writeln("Exit of program.");                                         
	exit(-1);
}


// returns an integer depended on the month
int monthConvert(string month){
  if (month=="Jan")
    return 1;
    if (month=="Feb")
    return 2;
    if (month=="Mar")
    return 3;
    if (month=="Apr")
    return 4;
    if (month=="May")
    return 5;
    if (month=="Jun")
    return 6;
    if (month=="Jul")
    return 7;
    if (month=="Aug")
    return 8;
    if (month=="Sep")
    return 9;
    if (month=="Oct")
    return 10;
    if (month=="Nov")
    return 11;
    if (month=="Dec")
    return 12;
    
    return 0;
}


//returns the oldest between the two
tweeter comparison(tweeter tweet,tweeter temp){
  if (tweet.year>temp.year)
            tweet=temp;
        else if (tweet.year==temp.year){
                  if (monthConvert(tweet.month)>monthConvert(temp.month))
                    tweet=temp;
                  else if (tweet.month==temp.month){
                          if (tweet.date>temp.date)
                            tweet=temp;
                          else if (tweet.date==temp.date){
                                  if (tweet.hour>temp.hour)
                                    tweet=temp;
                                  else if (tweet.hour==temp.hour){
                                          if (tweet.min>temp.min)
                                            tweet=temp;
                                          else if (tweet.min==temp.min){
                                                  if (tweet.sec>temp.sec)
                                                    tweet=temp;
                                          }//min statement
                                  }//hour statement
                          } //date stetatement
                  } //month statement 
          } //if (tweet.year==temp.year)
          
  return tweet;

}


// swap two rays msgs
rayzit[int] R_sort(rayzit[int] rayz,int k){
   rayzit temp;
    
   while (k!=0){ 
      if (rayz[k].timestamp<rayz[k-1].timestamp){
        temp = rayz[k-1];
        rayz[k-1] = rayz[k];
        rayz[k] = temp;
      }
      else
        break; 
     k--;
   }
   
   return rayz;
}


// swap 2 tweeter msgs
tweeter[int] T_sort(tweeter[int] tweet,int k){
   tweeter temp;
    
   while (k!=0){
    temp=comparison(tweet[k-1],tweet[k]);
    if (temp.file_name==tweet[k].file_name){
      tweet[k]=tweet[k-1];
      tweet[k-1]=temp;
    }
    else
      break; 
    k--;
   }
   
   return tweet;

}


// sorting the rays and tweets msgs from the geo_msgs folder
void geoSort(){
  auto rFiles = dirEntries("./geo_msgs/rayzit_msgs", "*.txt", SpanMode.shallow);
  auto tFiles = dirEntries("./geo_msgs/twitter_msgs", "*.txt", SpanMode.shallow);
  
  int k=0,j=0,c=1;
  string[] words;
  rayzit[int] rayz;
  rayzit rayzt;
  tweeter[int] tweet;
  tweeter tweett;
    
  
  //rayzit msgs
  foreach (rFile; rFiles) {   
    auto contents=to!string(read(rFile));
    
    foreach(i,line; splitLines(contents)){
      c=0;
      if (i==1){
        foreach(word; split(strip(line))){
          if (c==1){
            rayzt.timestamp = word;
            rayzt.file_name = rFile;
            rayz[k]=rayzt;
            if (k!=0){
              rayz = R_sort(rayz,k);
            }
            k++; 
          }   // if c==1
          c++;
        } //foreach word 
      } // if i == 1
    } // foreach i
  } // foreach rFile

   writeln("--------------------");
  writeln("Rayzs messages sorted \n");
   writeln("--------------------");
  while(j<k){
    writeln(to!string(read(rayz[j].file_name)));
    j++;
  }


  //tweeter msgs
  k=0;
  foreach (tFile; tFiles) {    
    auto contents=to!string(read(tFile));
    
    foreach(i,line; splitLines(contents)){
      c=0;
      if (i==1){
        foreach(word; split(strip(line))){
          if (c>1){
            switch (c){
            case 2:
              tweett.month = word;
              break;
            case 3:
             tweett.date = word;
             break;
            case 4:
             string[] test = word.split(":");
              tweett.hour = test[0];
              tweett.min = test[1];
              tweett.sec = test[2];
              break;
            case 6:
             tweett.year = replace(word,"\"","");
              break;
            default:
              break;
            }  //case statement
          } //if c>1
          
          c++;  
        } //foreach word
        tweett.file_name=tFile;
        tweet[k]=tweett;
        if (k!=0){
          T_sort(tweet,k);
        }
        break;
        }// if i==1
    }
    k++;
  }
  
  writeln("-----------------------");
  writeln("Tweeter messages sorted \n");
  writeln("-----------------------");
  j=0;
  while(j<k){
    writeln(to!string(read(tweet[j].file_name)));
    j++;
  }
}


// sorting the rays and tweets msgs from the latest_msgs folder
void latestSort(){
  auto rFiles = dirEntries("./latest_msgs/rayzit_msgs", "*.txt", SpanMode.shallow);
  auto tFiles = dirEntries("./latest_msgs/twitter_msgs", "*.txt", SpanMode.shallow);
  
  int k=0,j=0,c=1;
  string[] words;
  rayzit[int] rayz;
  rayzit rayzt;
  tweeter[int] tweet;
  tweeter tweett;
    
  
  //rayzit msgs
  foreach (rFile; rFiles) {   
    auto contents=to!string(read(rFile));
    
    foreach(i,line; splitLines(contents)){
      c=0;
      if (i==1){
        foreach(word; split(strip(line))){
          if (c==1){
            rayzt.timestamp = word;
            rayzt.file_name = rFile;
            rayz[k]=rayzt;
            if (k!=0){
              rayz = R_sort(rayz,k);
            }
            k++; 
          }   // if c==1
          c++;
        } //foreach word 
      } // if i == 1
    } // foreach i
  } // foreach rFile

   writeln("--------------------");
  writeln("Rayzs messages sorted \n");
   writeln("--------------------");
  while(j<k){
    writeln(to!string(read(rayz[j].file_name)));
    j++;
  }


  //tweeter msgs
  k=0;
  foreach (tFile; tFiles) {    
    auto contents=to!string(read(tFile));
    
    foreach(i,line; splitLines(contents)){
      c=0;
      if (i==1){
        foreach(word; split(strip(line))){
          if (c>1){
            switch (c){
            case 2:
              tweett.month = word;
              break;
            case 3:
             tweett.date = word;
             break;
            case 4:
             string[] test = word.split(":");
              tweett.hour = test[0];
              tweett.min = test[1];
              tweett.sec = test[2];
              break;
            case 6:
             tweett.year = replace(word,"\"","");
              break;
            default:
              break;
            }  //case statement
          } //if c>1
          
          c++;  
        } //foreach word
        tweett.file_name=tFile;
        tweet[k]=tweett;
        if (k!=0){
          T_sort(tweet,k);
        }
        break;
        }// if i==1
    }
    k++;
  }
  
  writeln("-----------------------");
  writeln("Tweeter messages sorted \n");
  writeln("-----------------------");
  j=0;
  while(j<k){
    writeln(to!string(read(tweet[j].file_name)));
    j++;
  }
}


// finding all the rays and tweets from the geo_msgs folder before the given year
void geoBeforeDate(string year){
  //auto rFiles = dirEntries("./geo_msgs/rayzit_msgs", "*.txt", SpanMode.shallow);
  auto tFiles = dirEntries("./geo_msgs/twitter_msgs", "*.txt", SpanMode.shallow);
  
  int k=0,j=0,c=1;
  string[] words;
  
  
  writeln("Tweets Before ",year,"\n");
  writeln("   ------------");  
  
  foreach (tFile; tFiles) {
    k++;    
    auto contents=to!string(read(tFile));
    
    foreach(i,line; splitLines(contents)){
      c=0;
      if (i==1){
        foreach(word; split(strip(line))){
          if (c==6){
             if(year>word){
                writeln("Tweet: \n",to!string(read(tFile)));
                writeln("---------------------------------------------------");
              }
          } //if c==6
          
          c++;
         
        } //foreach word
      }// if i==1
    }
  }          
}


// finding at the screen the latest rays and the latest tweet from the latest_msgs folder
void latestOldest(){
  auto rFiles = dirEntries("./latest_msgs/rayzit_msgs", "*.txt", SpanMode.shallow);
  auto tFiles = dirEntries("./latest_msgs/twitter_msgs", "*.txt", SpanMode.shallow);   
                                                                                            
  int k=0,j=0,c=1;           
  uint[string] freqs;
  string[] words;
  tweeter temp,tweet;
  rayzit  rayz;
 
  foreach (rFile; rFiles) {    
    auto contents=to!string(read(rFile));
    
    foreach(i,line; splitLines(contents)){
      c=0;
      if (i==1){
        foreach(word; split(strip(line))){
          if (c==1){
            if  (rayz.timestamp=="0"){
             rayz.timestamp = word;
             rayz.file_name = rFile;
            }
            else if (rayz.timestamp>word){
             rayz.timestamp = word;
             rayz.file_name = rFile; 
            } 
          }   // if c==1
          c++;
        } //foreach word 
      } // if i == 1
    } // foreach i
  } // foreach rFile
 
 
  foreach (tFile; tFiles) {    
    auto contents=to!string(read(tFile));
    
    foreach(i,line; splitLines(contents)){
      c=0;
      if (i==1){
        foreach(word; split(strip(line))){
          if (c>1){
          switch (c){
          case 2:
            temp.month = word;
            break;
          case 3:
            temp.date = word;
            break;
          case 4:
            string[] test = word.split(":");
            temp.hour = test[0];
            temp.min = test[1];
            temp.sec = test[2];
            break;
          case 6:
            temp.year = replace(word,"\"","");
            break;
          default:
            break;
          }  //case statement
          } //if c>1
          
          c++;
          
        } //foreach word
        temp.file_name = tFile;
        tweet = comparison(tweet,temp);
        break;
        }// if i==1
    }
  }
  writeln("Latest Rayz: \n",to!string(read(rayz.file_name)),"\n");
  writeln("Latest Tweet: \n",to!string(read(tweet.file_name)),"\n");
}


// finding at the screen the latest rays and the latest tweet from the geo_msgs folder
void geoOldest(){
  auto rFiles = dirEntries("./geo_msgs/rayzit_msgs", "*.txt", SpanMode.shallow);
  auto tFiles = dirEntries("./geo_msgs/twitter_msgs", "*.txt", SpanMode.shallow);   
                                                                                          
  
  
  int k=0,j=0,c=1;           
  uint[string] freqs;
  auto f = File("lexicon.txt", "w");
  string[] words;
  tweeter temp,tweet;
  rayzit  rayz;
 
  foreach (rFile; rFiles) {
    k++;    
    auto contents=to!string(read(rFile));
    
    foreach(i,line; splitLines(contents)){
      c=0;
      if (i==1){
        foreach(word; split(strip(line))){
          if (c==1){
            if  (rayz.timestamp=="0"){
             rayz.timestamp = word;
             rayz.file_name = rFile;
            }
            else if (rayz.timestamp>word){
             rayz.timestamp = word;
             rayz.file_name = rFile; 
            } 
          }   // if c==1
          c++;
        } //foreach word 
      } // if i == 1
    } // foreach i
  } // foreach rFile
 
 
  foreach (tFile; tFiles) {
    k++;    
    auto contents=to!string(read(tFile));
    
    foreach(i,line; splitLines(contents)){
      c=0;
      if (i==1){
        foreach(word; split(strip(line))){
          if (c>1){
          switch (c){
          case 2:
            temp.month = word;
            //writeln(temp.month);
            break;
          case 3:
            temp.date = word;
            //writeln(temp.date);
            break;
          case 4:
            string[] test = word.split(":");
            temp.hour = test[0];
            temp.min = test[1];
            temp.sec = test[2];
            break;
          case 6:
            temp.year = replace(word,"\"","");
            break;
          default:
            break;
          }  //case statement
          } //if c>1
          
          c++;
          ++freqs[word];
          
        } //foreach word
        temp.file_name = tFile;
        tweet = comparison(tweet,temp);
        break;
        }// if i==1
    }
    words = freqs.keys;
  }
  writeln("Latest Rayz: \n",to!string(read(rayz.file_name)),"\n");
  writeln("Latest Tweet: \n",to!string(read(tweet.file_name)),"\n");
}



// implemented the all buld lexicon query creating a lexicon.txt
void allBuildLexicon(){
  auto content = to!string(read("latest.json"));
  //auto rFiles = dirEntries("./latest_msgs/latest_msgs/rayzit_msgs", "*.txt",SpanMode.shallow);
  auto rFiles = dirEntries("./latest_msgs/rayzit_msgs", "*.txt",SpanMode.shallow);
  auto tFiles = dirEntries("./latest_msgs/twitter_msgs", "*.txt", SpanMode.shallow);
  //--------------------------------------------------------------------------------
  auto r2Files = dirEntries("./geo_msgs/rayzit_msgs", "*.txt", SpanMode.shallow);
  auto t2Files = dirEntries("./geo_msgs/twitter_msgs", "*.txt", SpanMode.shallow);   
                                                                                          
  
  
  int k=0,j=0;           
  uint[string] freqs;
  auto f = File("lexicon.txt", "w");
  string[] words;
 
  foreach (rFile; rFiles) {
    k++;    
    auto contents=to!string(read(rFile));
    foreach(i,line; splitLines(contents))  
        foreach(word; split(strip(line)))
            ++freqs[word];

   words = freqs.keys;
  }  
   
    
  
  foreach (tFile; tFiles){
   
    auto contents=to!string(read(tFile));
    foreach(i,line; splitLines(contents))  
        foreach(word; split(strip(line)))
            ++freqs[word];

    words = freqs.keys;
  }
 //----------------------------------------------
   
  foreach (r2File; r2Files) {
    k++;    
               
    auto contents=to!string(read(r2File));     
    foreach(i,line; splitLines(contents))  
        foreach(word; split(strip(line)))
            ++freqs[word];

    words = freqs.keys;
    
  } 
 
  foreach (t2File; t2Files){
   
    auto contents=to!string(read(t2File));    
    foreach(i,line; splitLines(contents))  
        foreach(word; split(strip(line)))
            ++freqs[word];
    words = freqs.keys;
  }
  
  sort!((a,b)=> freqs[a]>freqs[b])(words);
  foreach(s;words) 
    f.writefln("%s\t\t%s",s,freqs[s]);
}


// main program for checking the arguments given by the user
void main(string[] args){
  if (args[1]=="all-build-lexicon")
    allBuildLexicon();
  else if (args[1]=="latest-oldest")
    latestOldest();
  else if (args[1]=="geo-oldest")
    geoOldest();
  else if (args[1]=="geo-before-date")
    if (args.length<3)
      usage();
    else
      geoBeforeDate(args[2]);
  else if (args[1]=="geo-sort")
    geoSort();
  else if (args[1]=="latest-sort")
    latestSort();
  else 
    usage(); 
}